import java.util.concurrent.atomic.AtomicIntegerFieldUpdater;

public class Counter2 implements Counter {
	protected volatile int counter;
	protected AtomicIntegerFieldUpdater<Counter2> updater;

	public Counter2() {
		counter = 0;
		updater = AtomicIntegerFieldUpdater.newUpdater(Counter2.class,
				"counter");
	}

	@Override
	public int getValue() {
		return counter;
	}

	@Override
	public void increment() {
		updater.incrementAndGet(this);
	}

	public void decrement() {
		updater.decrementAndGet(this);
	}

	@Deprecated
	public boolean set(int value) {
		return updater.compareAndSet(this, counter, value);
	}
}
