import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Set;

import org.eclipse.jdt.core.IField;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;

import org.eclipse.ltk.core.refactoring.Refactoring;
import org.eclipse.ltk.core.refactoring.participants.RenameRefactoring;

import org.eclipse.jdt.internal.corext.refactoring.rename.RenameFieldProcessor;

import de.fernunihagen.rtt.Test;
import de.fernunihagen.rtt.TestParam;
import de.fernunihagen.rtt.TestProcedureStep;

public class RenameRefactoringTest {
	private Iterator<String> toRename;

	@Test("field(?C,?F)")
	public TestProcedureStep testRenameField(@TestParam("?F") IField field)
			throws JavaModelException {
		RenameFieldProcessor processor = new RenameFieldProcessor(field);
		Refactoring rename = new RenameRefactoring(processor);

		StringBuffer buffer = new StringBuffer();
		buffer.append(field.getElementName());
		buffer.append('_');
		buffer.append("renamed");
		buffer.append(String.format("%X", field.hashCode()));

		processor.setNewElementName(buffer.toString());

		return TestProcedureStep.create(rename);
	}

	@Test("field(?C,?F)")
	public TestProcedureStep testRenameFieldToParameter(
			@TestParam("?C") IType declaringType, @TestParam("?F") IField field)
			throws JavaModelException {
		if (null == toRename) {
			IMethod[] methods = declaringType.getMethods();
			Set<String> toRename = new LinkedHashSet<String>();
			for (IMethod method : methods) {
				toRename.addAll(Arrays.asList(method.getParameterNames()));
			}
			this.toRename = toRename.iterator();
		}
		if (!toRename.hasNext()) {
			toRename = null;
			return TestProcedureStep.next();
		}

		RenameFieldProcessor processor = new RenameFieldProcessor(field);
		Refactoring rename = new RenameRefactoring(processor);

		processor.setNewElementName(toRename.next());

		return TestProcedureStep.create(rename, false);
	}
}
